/******************************************************************************
**
** Version initiale.
** ----------------
** Ce programme se compose de trois fonctions. La fonction de desitribution
** est charge de lire les caractres en provenance de l'entre standard,
** d'envoyer les chiffres  la fonction chiffre (par l'intermdiaire d'un
** appel de fonction classique) et les lettres  la fonction lettre (aussi par
** l'intermdiaire d'un appel de fonction).
** Une fois la fin de fichier atteinte, les fonctions renvoient leurs
** rsultats  la fonction de distribution qui affiche ensuite les rsultats.
**
**  2002, ric Renault pour l'Institut National des Tlcommunications.
**  2003, Denis Conan
**
******************************************************************************/

#include <assert.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

/*
** Somme des chiffres.
*/
int chiffre(int car) {
  static int somme = 0 ;
  
  if (car != EOF) {
    /* Somme des chiffres. */
    somme += (car - '0') ;
  } else {
    /* Renvoi du rsultat. */
    return somme ;
  }
  return 0 ;
}

/*
** Frquence des lettres.
*/
int* lettre(int car) {
  /* On suppose que le tableau est correctement initialis. */
  static int frequence['z' - 'a' + 1] ;
  
  if (car != EOF) {
    /* Incrment des frquences. */
    frequence [ tolower ( car ) - 'a' ] ++ ;
  } else {
    /* Renvoi du rsultat. */
    return frequence ;
  }
  return NULL ;
}

/*
** Distribution des caractres et affichage des rsultats.
*/
void distributeur() {
  int car, *frequence, i, somme ;
  
  /* Distribution des caractres. */
  do {
    car = getchar() ;
    if (isalpha(car) || (car == EOF)) {
      frequence = lettre ( car ) ;
    }
    if (isdigit(car) || (car == EOF)) {
      somme = chiffre(car);
    }
  } while(car != EOF);
  
  /* Lecture et affichage de la somme. */
  printf("Somme : %d", somme);
  
  /* Lecture et affichage des frequences. */
  for(i = 'a' ; i <= 'z' ; i ++) {
    printf(" ; %c : %d", i, frequence[i - 'a']) ;
  }
  printf("\n");
}

/*
** Lancement de la fonction de distribution.
*/
int main(int argc, char* argv[]) {
  /* Lancement du travail. */
  distributeur();
  
  /* Tout s'est bien termin. */
  exit(0);
}
